'１次元拡散解析V31の標準ﾓｼﾞｭｰﾙ      ［作成］黒田英夫(2023/04)
Imports System.Drawing.Printing

Module Diff1DCom
    '1次元の非定常拡散解析
    '両端は外部境界・・・不透過、濃度固定、濃度伝達、濃度流束の4種類
    '複数層（各均等ﾒｯｼｭ）
    '各層材料の拡散係数は濃度依存有り

    'V21での改良点・・・結果ファイルでタイトルを2行目に移動、
    '                   後処理メニューで解析結果の主要値表示を追加
    'V22での改良点・・・定常解析の等濃度線図で結果ファイル読み込みエラーを修正
    'V23での改良点・・・入力データ処理で結果ファイル読み込みのエラーを修正
    'V24での改良点・・・後処理の解析結果の主要値表示でクリップボードにコピーを追加
    'V25での改良点・・・各画面でボタンを読みやすい色に改善
    'V26での改良点・・・Visual Basic 2017に変更
    'V27での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードを標準でUTF-8に変更
    '                   （従来のShift-JISもオプションで可能）
    'V28での改良点・・・ファイル入出力画面でキャンセル処理の改善
    'V29での改良点・・・データ表画面で表計算ソフトから貼り付け時に次行に0が入るのを防止
    'V30での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V31での改良点・・・フリーソフト化、VB2022に移行、文字コードはUTF-8のみ採用

    Public CalcRes$                 '計算結果表示データ

    Public Cr$                      'CR+LFのコード
    Public DirOpen$                 '立ち上げ時のディレクトリー名
    Public Fm$                      '入力データのファイル名
    Public Fy$                      '計算結果のファイル名
    Public Title$                   'タイトル

    Public Timst As Date            '計算開始時刻

    Public Idcycle As Integer       '出力サイクル間隔
    Public InitData As Integer      '初期値データの入力区分
    '                               （0:各層一括、1:各点個別、2:結果ファイル読み込み）
    Public InOut As Integer         'ファイル入出力の種類（0:入力、1:出力）
    Public Kcolorfill As Integer    '等高線図のカラーフィルの有無（0:なし、1:有り）
    Public Kcycle As Integer        '作画指定のサイクル番号
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public KfileOK As Integer       'ﾌｧｲﾙのOK有無（0:なし、1:有り）
    Public KindDtimeU As Integer    '非定常の時間間隔の上限制約有無（0:なし、1:有り）
    '    Public KindEncod As Integer     'ファイルの文字コード（0:UTF-8、1:Shif-JIS）
    Public Kindex As Integer        'ﾃｷｽﾄｱﾚｲのｲﾝﾃﾞｯｸｽ
    Public KindPost As Integer      '後処理の区分（1:等濃度線図、2:ｽﾗｲﾄﾞｼｮｰ、3:端数処理、
    '                                4:主要値表示）
    Public KL1 As Integer           '作画の開始層番号
    Public KL2 As Integer           '作画の終了層番号
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public KnumDisp As Integer      '構造作画での番号表示（0:なし、1:有り）
    Public KnumMax As Integer       '節点番号の最大値
    Public KnumSb As Integer        'ﾌｫﾝﾄ文字ｻｲｽﾞの操作変数
    Public KnumSize As Integer      '構造作画での番号ｻｲｽﾞ
    Public Kscreen As Integer       '作画画面サイズ（0：全画面、1：通常画面）
    Public Kstep As Integer         '作画指定のステップ番号
    Public Ktime As Integer         '出力メッシュ番号
    Public MeshMax As Integer       '層の最大メッシュ数
    Public Mstat As Integer         '解析種別（0:定常、1:非定常）
    Public Nall As Integer          '変数の総数
    Public Ncycle As Integer        '境界条件のサイクル数
    Public NL As Integer            '層の数
    Public Nmat As Integer          '材料データ数
    Public NMdivMax As Integer      '材料の物性区分数最大値
    Public Nconc As Integer         '濃度分割数
    Public Nstep As Integer         '境界条件のステップ数
    Public Ntime As Integer         '非定常の出力時間メッシュ数

    Public Cfix As Single           'XY方向ﾋﾟｸｾﾙ差の補正係数
    Public ConcMin As Single        '最低濃度
    Public ConcMax As Single        '最高濃度
    Public DconcMax As Single       '非定常の計算1回の濃度変化許容値
    Public Dtime As Single          '非定常の出力の計算時間間隔
    Public DtimeInit As Single      '非定常の計算時間間隔の初期値
    Public TimeMax As Single        '非定常の打切り時間
    Public TimeNew As Single        '現在の計算時刻
    Public WidthL As Single         '構造の幅（作画用）
    Public Xlower As Single         '作画領域のX最小値
    Public Xupper As Single         '作画領域のX最大値
    Public XYscale As Single        '作画スケール
    Public Ylower As Single         '作画領域のY最小値
    Public Yupper As Single         '作画領域のY最大値

    Public ArrText As New ArrayList()

    Public UFileA(6) As String      '最近使用した入力ﾌｧｲﾙの保存配列

    Public KindBoundL() As Integer  '左端の境界種類（0:不透過、1:濃度固定、2:濃度伝達、3:濃度流束）
    Public KindBoundR() As Integer  '右端の境界種類（0:不透過、1:濃度固定、2:濃度伝達、3:濃度流束）
    Public KstartL() As Integer     '各層第1ﾒｯｼｭの対応変数番号
    Public Mesh() As Integer        '各層のメッシュ数
    Public NMdiv() As Integer       '材料の物性区分数
    Public NumMat() As Integer      '各層の材料種類番号

    Public BoundDataL(,) As Single  '左端境界の条件データ
    Public BoundDataR(,) As Single  '左端境界の条件データ
    Public ConcInit(,) As Single    '初期濃度
    Public ConcLB() As Single       '層左の層境界濃度
    Public ConcMat(,) As Single     '材料の区分上限濃度
    Public ConcSurf(2) As Single    '両端境界表面濃度
    Public DiffMat(,) As Single     '材料の区分上限拡散係数
    Public Rlength() As Single      '各層の長さ
    Public TimeStep() As Single     'ステップ時間
    Public Tu() As Single           '差分計算の解
    Public Xdraw(4), Ydraw(4) As Single     '色塗り多角形の座標
    Public Xmouse(), Ymouse() As Single     'ﾏｳｽ位置座標

    Sub DataStoreCheck(ByRef ix As Integer)
        'ﾃﾞｰﾀ保存の確認
        'ix･･･返答（6:yes、それ以外は中止）
        ix = 0
        If KdataChange > 0 Then
            Dim aa$
            aa$ = Fm$ + "ファイルが変更されていますが、保存なしでよいですか？"
            ix = MsgBox(aa$, 4, "データ変更の警告")
            If ix = 6 Then
                KdataChange = 0
            End If
        End If

    End Sub

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込みU
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$
        Dim i, j As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "Diffusion1D" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        NL = dat(1)
        ReDim Mesh(NL), NumMat(NL), Rlength(NL)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nmat = dat(1)
        ReDim NMdiv(Nmat)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nstep = dat(1)
        ReDim TimeStep(Nstep)
        ReDim KindBoundL(Nstep), BoundDataL(Nstep, 2)
        ReDim KindBoundR(Nstep), BoundDataR(Nstep, 2)

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        WidthL = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        InitData = dat(1)
        aa$ = sr.ReadLine
        For i = 1 To NL
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NumMat(i) = dat(1)
            Rlength(i) = dat(2)
            Mesh(i) = dat(3)
        Next i
        aa$ = sr.ReadLine
        NMdivMax = 0
        For i = 1 To Nmat
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NMdiv(i) = dat(1)
            If NMdiv(i) > NMdivMax Then
                NMdivMax = NMdiv(i)
            End If
        Next i
        ReDim ConcMat(Nmat, NMdivMax), DiffMat(Nmat, NMdivMax)
        aa$ = sr.ReadLine
        For i = 1 To Nmat
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
            For j = 0 To NMdiv(i)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                ConcMat(i, j) = dat(1)
                DiffMat(i, j) = dat(2)
            Next j
        Next i

        If Nstep > 1 Then
            aa$ = sr.ReadLine
            For i = 1 To Nstep
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                TimeStep(i) = dat(1)
            Next i
        End If

        aa$ = sr.ReadLine
        For i = 1 To 2
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
            For j = 1 To Nstep
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                If i = 1 Then
                    KindBoundL(j) = dat(1)
                    BoundDataL(j, 1) = dat(2)
                    BoundDataL(j, 2) = dat(3)
                Else
                    KindBoundR(j) = dat(1)
                    BoundDataR(j, 1) = dat(2)
                    BoundDataR(j, 2) = dat(3)
                End If
            Next j
        Next i

        For i = 1 To NL
            If i = 1 Then
                MeshMax = Mesh(i)
            ElseIf Mesh(i) > MeshMax Then
                MeshMax = Mesh(i)
            End If
        Next i

        If InitData > 0 Then
            ReDim ConcInit(NL, MeshMax)
            aa$ = sr.ReadLine
            For i = 1 To NL
                aa$ = sr.ReadLine
                For j = 1 To Mesh(i)
                    aa$ = sr.ReadLine
                    dat = aa.Split(",")
                    ConcInit(i, j) = dat(1)
                Next j
                ConcInit(i, 0) = ConcInit(i, 1)
            Next i
        End If
        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出しU
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i, j, jmax As Integer

        Dim sw As New IO.StreamWriter(fxx$)

        aa$ = "プログラム名" + "," + "Diffusion1D"
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "層の数" + "," + Str(NL)
        sw.WriteLine(aa$)
        aa$ = "材料データ数" + "," + Str(Nmat)
        sw.WriteLine(aa$)
        aa$ = "境界条件のステップ数" + "," + Str(Nstep)
        sw.WriteLine(aa$)
        aa$ = "構造の幅（作画用）" + "," + Str(WidthL)
        sw.WriteLine(aa$)
        aa$ = "初期値データの有無" + "," + Str(InitData)
        sw.WriteLine(aa$)

        aa$ = "各層の形状データ（層番号、材料番号、長さ、分割メッシュ数）"
        sw.WriteLine(aa$)
        For i = 1 To NL
            aa$ = "  " + Str$(i) + ",  " + Str$(NumMat(i))
            aa$ = aa$ + ",  " + Str$(Rlength(i)) + ",  " + Str$(Mesh(i))
            sw.WriteLine(aa$)
        Next i
        sw.WriteLine("各材料の物性区分数（材料番号、区分数)")
        For i = 1 To Nmat
            aa$ = "  " + Str$(i) + ",  " + Str$(NMdiv(i))
            sw.WriteLine(aa$)
        Next i
        sw.WriteLine("各材料の物性データ")
        For i = 1 To Nmat
            aa$ = "材料番号" + "," + Str(i)
            sw.WriteLine(aa$)
            sw.WriteLine("  区分番号、濃度、拡散係数")
            For j = 0 To NMdiv(i)
                aa$ = "    " + Str$(j) + ",  " + Str$(ConcMat(i, j))
                aa$ = aa$ + ",  " + Str$(DiffMat(i, j))
                sw.WriteLine(aa$)
            Next j
        Next i

        If Nstep > 1 Then
            sw.WriteLine("境界条件のステップ時間（ステップ番号、時間）")
            For i = 1 To Nstep
                aa$ = Str$(i) + ",  " + Str$(TimeStep(i))
                sw.WriteLine(aa$)
            Next i
        End If

        sw.WriteLine("両端境界のデータ")
        For i = 1 To 2
            aa$ = "境界番号" + "," + Str(i)
            sw.WriteLine(aa$)
            aa$ = "　ステップ番号、境界種類（0:不透過、1:濃度固定、2:濃度伝達、3:濃度流束）、各データ"
            sw.WriteLine(aa$)
            For j = 1 To Nstep
                aa$ = Str(j)
                If i = 1 Then
                    aa$ = aa$ + ",  " + Str(KindBoundL(j))
                    aa$ = aa$ + ",  " + Str(BoundDataL(j, 1))
                    aa$ = aa$ + ",  " + Str(BoundDataL(j, 2))
                Else
                    aa$ = aa$ + ",  " + Str(KindBoundR(j))
                    aa$ = aa$ + ",  " + Str(BoundDataR(j, 1))
                    aa$ = aa$ + ",  " + Str(BoundDataR(j, 2))
                End If
                sw.WriteLine(aa$)
            Next j
        Next i

        If InitData > 0 Then
            sw.WriteLine("初期濃度データ（メッシュ番号、濃度）")
            For i = 1 To NL
                aa$ = "層番号" + "," + Str(i)
                sw.WriteLine(aa$)
                jmax = Mesh(i)
                For j = 1 To jmax
                    aa$ = Str$(j) + ",  " + Str$(ConcInit(i, j))
                    sw.WriteLine(aa$)
                Next j
            Next i
        End If

        sw.Close()

        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Sub FileName(ByVal fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Diff1DMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            Kscreen = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Diff1DMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.WriteLine(Kscreen)
        sw.Close()

    End Sub

    Sub PaintExe(ByRef gr As Graphics, ByVal ncount As Integer, _
        ByVal colorx As Color, ByVal kind As Integer)
        '塗りつぶし実行
        'gr･･･ｸﾞﾗﾌｨｯｸｽ･ｵﾌﾞｼﾞｪｸﾄ名
        'ncount･･･頂点数
        'colorx･･･境界および塗りつぶしの色
        'kind･･･境界作画の有無（0:なし、1:有り）
        Dim i As Integer
        Dim xydraw(ncount - 1) As Point
        Dim myBrush As New SolidBrush(colorx)

        For i = 1 To ncount
            xydraw(i - 1).X = Xdraw(i)
            xydraw(i - 1).Y = Ydraw(i)
        Next i
        gr.FillPolygon(myBrush, xydraw)

        If kind > 0 Then
            gr.DrawPolygon(Pens.Black, xydraw)
        End If

    End Sub

    Sub RoundPrep(ByRef kind As Integer, ByRef nb As Integer, ByVal zb As Single)
        '丸め準備
        'kind･･･丸め区分（0:1以上、1:1未満）
        'nb･･･丸め位置の桁数
        'zb･･･丸め基準値
        Dim i, ib As Integer
        Dim b2 As Single

        b2 = zb
        nb = 0
        i = Int(b2)
        If i > 0 Then
            kind = 0
            Do
                ib = CInt(b2)
                If ib < 10 Then
                    Exit Do
                Else
                    nb = nb + 1
                    b2 = b2 * 0.1
                End If
            Loop
        Else
            kind = 1
            Do
                ib = CInt(b2)
                If ib > 0 Then
                    Exit Do
                Else
                    nb = nb + 1
                    b2 = b2 * 10
                End If
            Loop
        End If

    End Sub

    Sub RoundTreat(ByVal kind As Integer, ByVal nb As Integer, ByRef zb As Single)
        '丸め処理
        'kind･･･丸め区分（0:1以上、1:1未満）
        'nb･･･丸め位置の桁数
        'zb･･･対象変数
        Dim ib As Integer
        Dim b1 As Single

        If kind = 0 Then
            b1 = zb * 10 ^ (-nb)
            ib = CInt(b1)
            zb = ib * 10 ^ nb
        Else
            b1 = zb * 10 ^ nb
            ib = CInt(b1)
            zb = ib * 10 ^ (-nb)
        End If

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Diffusion1D.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Diffusion1D.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\Diff1DUFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\Diff1DUFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

    Sub XYCalc(ByRef xb As Single, ByRef yb As Single)
        'X,Yの作画座標計算
        'xb･･･X座標値
        'yb･･･Y座標値
        If Cfix < 1 Then
            xb = xb * XYscale + Xlower
            yb = Yupper - yb * XYscale * Cfix
        Else
            xb = xb * XYscale / Cfix + Xlower
            yb = Yupper - yb * XYscale
        End If
    End Sub

End Module
